<?php
namespace Teknisa\CRM\Factory;

use Doctrine\ORM\EntityManager;

class DashboardFactory
{
    
    protected $connection;
    
    public function __construct(EntityManager $entityManager) {
        
        $this->connection       = $entityManager->getConnection();
    }
    
    public function getPivotedTermometro($nrorg, $opers, $colors){
        $select = "SELECT * FROM
                    (
                      SELECT COUNT(NRSEQOPORT) AS QUANTIDADE, DECODE(NMTERMOPORTUNI, NULL, 'SEMTERM', NMTERMOPORTUNI) AS TERMOMETRO, NMPRINCIPALPARC AS OPERADOR, OP.NRPARCNEGOCIO, OP.CDOPERADOR FROM
                        CRM_OPORTUNI OPORT
                        LEFT JOIN CRM_TERMOPORTUNI TERM
                        ON TERM.NRTERMOPORTUNI = OPORT.NRTERMOPORTUNI
                        AND TERM.NRORG = OPORT.NRORG
                        JOIN PARCNEGOCIO PARC
                        ON PARC.NRPARCNEGOCIO = OPORT.NRPARCRESP
                        JOIN OPERADOR OP
                        ON PARC.NRPARCNEGOCIO = OP.NRPARCNEGOCIO
                        AND PARC.NRORG = OP.NRORG
                        AND OPORT.NRPARCRESP IN($opers)
                        AND OPORT.NRORG = $nrorg 
                        AND OPORT.DTREALFECHA IS NULL
                        GROUP BY OPORT.NRTERMOPORTUNI, NMTERMOPORTUNI, DSCORHEXADECIMAL, NRPARCRESP, NMPRINCIPALPARC, op.nrparcnegocio, op.cdoperador
                    )
                    PIVOT 
                    (
                      MAX(QUANTIDADE)
                      FOR TERMOMETRO
                      IN ($colors)
                    )";
        
        
        $std = $this->connection->prepare($select);
        $std->execute();
        return $std->fetchAll();
    }
    
    
}
?>