function crm00001002_Natureza_Perfil_Atividade(General, CRM_Utilities, ScreenService) {
    
    /**
     * Função para salvar uma natureza
     * ao perfil de atividade em caso.
     * 
     * @param {object} widget widget ativa onde está
     * sendo realizado o cadastro da natureza.
    */
    this.saveNewActivityProfileNatureza = function(widget){
        
        var currentRow = widget.currentRow;
        
        var activityProfileNatureza = currentRow.NATUREZAS;
        var rows = [];
        
        activityProfileNatureza.forEach(function(natu, natuIndex){
            
            rows.push(this.setActivityProfileNaturezaValuesInCurrentRow(widget, natuIndex));
                
        }.bind(this)); 
        
        General.callRestEngine("product#/crm_perfinatucont_natucont/save", "DataSet", rows).then(function(response){
                
                ScreenService.closeSwipe().then(function(){
                    
                    widget.reload();
                    
                });
                
        }.bind(this));
    };
    
    /**
     * Função para pegar as informações do 
     * array de natureza na currentRow, e
     * tratá-las em uma cópia da currentRow para
     * realizar o save.
     * 
     * @param {object} widget widget ativa onde está
     * sendo realizado o cadastro da natureza.
     * 
     * @param {int} resultIndex index da natureza
     * no array de naturezas presente na currentRow.
    */
    this.setActivityProfileNaturezaValuesInCurrentRow = function(widget, natuIndex){
        
        var currentRow = angular.copy(widget.currentRow);
        var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();
        
        currentRow.__is_new = true;
        currentRow.NRSEQPERFATIV = widget.parent.parent.currentRow.NRSEQPERFATIV;
        currentRow.CDNATUCONT = currentRow.NATUREZAS[natuIndex];
        currentRow.NRORG = loggedOperatorInfos.NRORG;
        
        return currentRow;
        
    };
    
    /**
     * Função para inserir um filtro na field
     * de naturezas e logo em seguida,
     * atualiza a field.
     * 
     * @param {object} widget widget ativa no
     * modo edit, onde está sendo mostrado o campo
     * de natureza.
    */
    this.insertNatucontFilter = function(widget){
        
        var natuField = widget.getField("NATUREZAS");
        var natuFieldFilter = natuField.dataSourceFilter;
        
        var nrseqperfativIndex = CRM_Utilities.getFilterPosition(natuFieldFilter, "P_NRSEQPERFATIV");
        
        natuFieldFilter[nrseqperfativIndex].value = widget.parent.parent.currentRow.NRSEQPERFATIV;
        
        natuField.reload();
    };
    
}

Configuration(function(ContextRegister) {
    ContextRegister.register('crm00001002_Natureza_Perfil_Atividade', crm00001002_Natureza_Perfil_Atividade);
});