describe("MetadataEnrichment", function() {

	var container = { "widget":"widget", "fields": "test" };
	var metadataEnrichment;

	beforeEach(function(){
		window.templateUrl = "../../dyman/templates/dyman/";
		window.metadataUrl = "/json_test/test";
		window.serviceUrl = "../backend/service/index.php";    
		module('ZeedhiApp');
		metadataEnrichment = MetadataEnrichment;
	});

	it("MetadataEnrichment should copy the object into the object.", function () {
		metadataEnrichment.enrich(container);
		expect(container.__metadata.widget).toBe(container.widget);
	});

	it("MetadataEnrichment when change container shouldn't change the __metadata object.", function () {
		var testEnrich = container.widget;
		metadataEnrichment.enrich(container);
		container.widget = "this is a new widget";
		expect(container.__metadata.widget).toBe(testEnrich);
	});
});
