/* global ZeedhiApp, ZeedhiServices, ContainerDecoratorDeveloper,
DeveloperService, ShortcutDeveloperService, DTCustomizationService,
ElementFileService,  ElementToMetadataService, DeveloperToolsForm,
DeveloperTreeService, DTServerService, DTCustomizationDecorator,
DeveloperMenuEnrichment, DTMessages, DTRenderService, SocketService,
DTCustomComponentCRUD, DTComponentCRUD FileManagementService*/

ZeedhiServices.service("DTMessages", function(ApplicationContext) {
	var instance = new DTMessages();
	ApplicationContext.registerInstance("DTMessages", instance);
	return instance;
});

ZeedhiServices.service("DTServerService", function(ApplicationContext, $http, ScreenService, DTMessages, DevToolsService) {
	var instance = new DTServerService($http, ScreenService, DTMessages, DevToolsService);
	ApplicationContext.registerInstance("DTServerService", instance);
	return instance;
});

ZeedhiServices.service("DTRenderService", function(ApplicationContext, templateManager, metaDataFactory) {
	var instance = new DTRenderService(metaDataFactory, templateManager, ApplicationContext);
	ApplicationContext.registerInstance("DTRenderService", instance);
	return instance;
});

ZeedhiServices.service("DTCustomizationService", function(ApplicationContext, templateManager, ZHPromise, DTServerService, DTMessages, DTRenderService) {
	var instance = new DTCustomizationService(templateManager, ZHPromise, DTServerService, DTMessages, DTRenderService);
	ApplicationContext.registerInstance("DTCustomizationService", instance);
	return instance;
});

ZeedhiApp.run(function(ContextRegister, ContainerDecoratorProvider, ZHPromise, templateManager, eventEngine, DevToolsService, DTCustomizationService) {
	DevToolsService.inDeveloperModePromise.then(function(response){
		if(response.inCustomizationMode){
			ContainerDecoratorProvider.registerProvider(new DTCustomizationDecorator(ZHPromise, DTCustomizationService));
			ContextRegister.register('DTComponentCRUD', DTCustomComponentCRUD);
		}
		if(response.inDeveloperMode){
			eventEngine.registerEvent("ContainerOnRender", "onRender");
			eventEngine.registerEvent("WidgetOnRender", "onRender");
			ContainerDecoratorProvider.registerProvider(new ContainerDecoratorDeveloper(ZHPromise, templateManager));
			DeveloperMenuEnrichment.enrich(templateManager.project);
			if(!response.inCustomizationMode){
				ContextRegister.register('SocketService', SocketService);
				ContextRegister.register('DTComponentCRUD', DTComponentCRUD);
				ContextRegister.register('FileManagementService', FileManagementService);
			}
		}
	});
});

ZeedhiServices.service("DevToolsService", function(restEngine, localStorageEngine, templateManager){
	return new DeveloperService(restEngine, localStorageEngine, templateManager);
});

ZeedhiServices.service("DeveloperToolsForm", function(ApplicationContext, ScreenService, templateManager, DevToolsService, metaDataFactory){
	var instance = new DeveloperToolsForm(metaDataFactory, ScreenService, templateManager, DevToolsService);
	ApplicationContext.registerInstance("DeveloperToolsForm", instance);
	return instance;
});

ZeedhiServices.service("DeveloperTreeService", function(ApplicationContext, DevToolsService){
	var instance = new DeveloperTreeService(DevToolsService);
	ApplicationContext.registerInstance("DeveloperTreeService", instance);
	return instance;
});

ZeedhiServices.service("ShortcutDeveloperService", function(ApplicationContext, metaDataFactory){
	var instance = new ShortcutDeveloperService(metaDataFactory);
	ApplicationContext.registerInstance("ShortcutDeveloperService", instance);
	return instance;
});

ZeedhiServices.service("ElementToMetadataService", function(ApplicationContext, templateManager) {
	var instance = new ElementToMetadataService(templateManager);
	ApplicationContext.registerInstance("ElementToMetadataService", instance);
	return instance;
});

ZeedhiServices.service("ElementFileService", function(ApplicationContext, DevToolsService) {
	var instance = new ElementFileService(DevToolsService);
	ApplicationContext.registerInstance("ElementFileService", instance);
	return instance;
});
